MAKEFLAGS += --no-builtin-rules
MAKEFLAGS += --no-builtin-variables
$(foreach x,$(filter-out .% MAKE% SHELL CURDIR,$(.VARIABLES)) MAKEINFO,$(if $(filter default,$(origin $x)),$(eval override undefine $x)))

CXX ?= g++
CC ?= gcc

CFLAGS ?= -O2 -Wall -Wextra
CXXFLAGS ?= -O2 -Wall -Wextra

%: %.c
	which $(CC) || { echo "No $(CC) in PATH, execute blem with CC set to g++ (e.g. CXX=g++-14 blem)" >&2; exit 1; }
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH) $^ $(LOADLIBES) $(LDLIBS) -o $@

%: %.cpp
	which $(CXX) || { echo "No $(CXX) in PATH, execute blem with CXX set to g++ (e.g. CXX=g++-14 blem)" >&2; exit 1; }
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH) $^ $(LOADLIBES) $(LDLIBS) -o $@

%: %.py
	which pypy3 || { echo "No pypy3 in PATH" >&2; exit 1; }
	echo "#!/usr/bin/env pypy3" | cat - $< >$@
	chmod +x $@

%: %.java
	which javac || { echo "No javac in PATH" >&2; exit 1; }
	javac $<
	echo '#!/usr/bin/env bash\ncd "$$(dirname "$$0")"\njava -Xms1024m -Xmx1024m -Xss100m $(shell basename "$@")' >$@
	chmod +x $@
