TEST_CASE_NUMBER = 0
LANG = 'br'
SAMPLE_INPUT = 'Exemplo de entrada'
SAMPLE_OUTPUT = 'Exemplo de saída'
COPY_BUTTON_LABEL = 'Copiar'
COPY_BUTTON_HTML = '<button onclick="navigator.clipboard.writeText(this.parentNode.parentNode.childNodes[1].textContent);">' .. COPY_BUTTON_LABEL .. '</button>'

function html_escape(s)
    return s:gsub("&", "&amp;"):gsub("<", "&lt;"):gsub(">", "&gt;")
end

function generate_html_example(in_content, out_content)
  return '<div class="sample">' ..
    '<div class="sample-input">' ..
    '<div class="sample-title">' .. SAMPLE_INPUT .. ' ' .. TEST_CASE_NUMBER .. COPY_BUTTON_HTML .. '</div>' ..
    '<pre>' .. html_escape(in_content) .. '</pre>' ..
    '</div>' ..
    '<div class="sample-output">' ..
    '<div class="sample-title"> ' .. SAMPLE_OUTPUT .. ' ' .. TEST_CASE_NUMBER .. COPY_BUTTON_HTML .. '</div>' ..
    '<pre>' .. html_escape(out_content) .. '</pre>' ..
    '</div>' ..
    '</div>'
end

function generate_latex_example(in_content, out_content)
  return '\\vspace{2pt}' ..
    '\\noindent' ..
    '\\begin{minipage}[c]{0.95\\textwidth}' ..
    '\\begin{center}' ..
    '\\begin{tabular}{|l|l|} \\hline' ..
    '\\begin{minipage}[t]{0.5\\textwidth}' ..
    '\\bf{\\small ' .. SAMPLE_INPUT .. ' ' .. TEST_CASE_NUMBER .. '}' ..
    '\\begin{verbatim}' .. in_content .. '\\end{verbatim}\\vspace{.5em}' ..
    '\\end{minipage}' ..
    '&' ..
    '\\begin{minipage}[t]{0.5\\textwidth}' ..
    '\\bf{\\small ' .. SAMPLE_OUTPUT .. ' ' .. TEST_CASE_NUMBER .. '}' ..
    '\\begin{verbatim}' .. out_content .. '\\end{verbatim}\\vspace{.5em}' ..
    '\\end{minipage} \\\\' ..
    '\\hline' ..
    '\\end{tabular}' ..
    '\\end{center}' ..
    '\\end{minipage}'
end

function RawBlock(el)
  local matched = el.text:match("\\example{(.+)}")
  if matched ~= nil then
    local filename = matched
    TEST_CASE_NUMBER = TEST_CASE_NUMBER + 1
    local base_directory = PANDOC_STATE.output_file:match("(.*/)")
    local in_file = io.open(base_directory .. '../artifacts/testcases/' .. filename .. '.in')
    local in_content = in_file:read('*all')
    in_file:close()
    local out_file = io.open(base_directory .. '../artifacts/testcases/' .. filename .. '.sol')
    local out_content = out_file:read('*all')
    out_file:close()
    if FORMAT == 'html' then
      return pandoc.RawBlock('html', generate_html_example(in_content, out_content))
    elseif FORMAT == 'latex' then
      return pandoc.RawBlock('latex', generate_latex_example(in_content, out_content))
    else
      return el
    end
  else
   return el
  end
end
